#!/bin/sh

# Copyright (C) 2024 Simon Josefsson <simon@josefsson.org>

# This file is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

set -e

cppi --version
echo "PASS: cppi --version"
cppi --help
echo "PASS: cppi --help"

man -P cat cppi
echo "PASS: man cppi"

WORKDIR=$(mktemp -d)
trap "rm -rf $WORKDIR" 0 INT QUIT ABRT PIPE TERM

cd $WORKDIR

cat <<EOF > input.c
#include <ntlm.h>
#define FOO
#ifdef FOO
#define BAR
#ifdef BAZ
#define NOP
#endif
#endif
EOF

cat <<EOF > expect.c
#include <ntlm.h>
#define FOO
#ifdef FOO
# define BAR
# ifdef BAZ
#  define NOP
# endif
#endif
EOF

tail -v -n+0 input.c
tail -v -n+0 expect.c

cppi input.c > output.c

tail -v -n+0 output.c

echo "PASS: cppi"

diff -ur expect.c output.c
echo "PASS: diff"

if cppi --check input.c 2> /dev/null; then
   echo "FAIL: cppi --check input.c"
   exit 1
fi
echo "PASS: cppi --check input.c"

if ! cppi --check expect.c; then
   echo "FAIL: cppi --check expect.c"
   exit 1
fi
echo "PASS: cppi --check expect.c"

exit 0
